#!/usr/bin/perl

require '../common/wwwutil';
require '../common/ptime';


print "Content-type: text/html\n\n";

print "<body bgcolor=ffffff>";


# get a rfq number
$rfq = '/home/nobody/quno';
open(RFQ, "<$rfq");
$number = <RFQ>;
close(RFQ);
open(RFQ, "+>$rfq");
print RFQ ++$number;
close(RFQ);


#$userlog = <./user.log>;
#open(USERLOG, ">>$userlog");

# open stdin
read(STDIN, $_, $ENV{'CONTENT_LENGTH'});

# take string apart
@a = split(/&/);

# scan array for P and put in pn array
while (@a) {
    $a = shift(@a);
    if ($a =~ /^P=/) {
	@t = split(/=/, $a);
	$t[1] = &unescape($t[1]);
	$t[1] = uc $t[1];
	push(@pn, $t[1]);
	
	for (1..4) {
	    $a = shift(@a);
	    @t = split(/=/, $a);
	    $t[1] = &unescape($t[1]);
	    $t[1] = uc $t[1];
	    push(@pn, $t[1]);
	}
    } else {
	@t = split(/=/, $a);
	for ($i = 0; $i < 2; $i++) {
	    push(@var, &unescape($t[$i]));
	}
    }
}


# convert @var into associative array
%var = @var;
$var{'rfqnumber'} = $number;


# get user info
@user = &userinfo("$ENV{'REMOTE_USER'}");

chop $user[0];
@a = split(/\t/, $user[0]);
$var{'invoicedby'} = $a[0];
$var{'myemail'} = $a[1];


@dt = &now;
$var{'dateinvoiced'} = $dt[0];
$var{'timeinvoiced'} = $dt[1];


$msg = $var{'message'};
$msg =~ s/\n\n/<p>/g;
$msg =~ s/\n/<br>/g;


print "
<center>
<table cellpadding=10>
<tr align=center><td><img src=/images/fdp.gif></td>
<td><h3>";

# print header
@a = split(/\t/, $user[1]);
foreach $item (@a) {
    print "$item<br>";
}
$mycompany = $a[0];
# translate tabs to newline and save in myheader var
$user[1] =~ tr/\t/\n/;
$var{'myheader'} = &escape($user[1]);


print "</h3>
</td></tr>
</table>
</center>


<H1 align=center>*** I N V O I C E ***<HR></H1>
<p><form method=post action=xmitinvoice.pl>

<table border=1 cellpadding=5>
<tr>
<th>Invoice #:</th><td>$var{'rfqnumber'}</td>
<th align=right>Date:</th><td>$var{'dateinvoiced'}</td>
<th>Terms:</th><td>$var{'terms'}</td><td>$var{'currency'}</td>
<th>Freight:</th><td>$var{'freight'}</td>
</tr>
</table>

<p>

<table cellpadding=10>
  <tr valign=top>
  <td width=350>
  <table>";

print "<tr><th align=right></th><td>$var{'name'}</td></tr>";
print "<tr><th></th><td>$var{'addr1'}</td></tr>" if ($var{'addr1'});
print "<tr><th></th><td>$var{'addr2'}</td></tr>" if ($var{'addr2'});
print "<tr><th></th><td>$var{'addr3'}</td></tr>" if ($var{'addr3'});

print "
  </table>
  </td>
  <td width=250>
  <table>";
print "<tr><th align=right>Tel:</th><td>$var{'phone'}</td></tr>" if ($var{'phone'});
print "<tr><th align=right>Fax:</th><td>$var{'fax'}</td></tr>" if ($var{'fax'});
print "<tr><th align=right>email:</th><td>$var{'email'}</td></tr>" if ($var{'email'});
print "</table></td>
  </tr>
</table>

<p>
  <table>

<tr>";
print "<th>Make:</th><td>$var{'make'}</td><td width=20>&nbsp;</td>" if $var{'make'};
print "<th>Model:</th><td>$var{'model'}</td><td width=20>&nbsp;</td>" if $var{'model'};
print "<th>Serial Number:</th><td>$var{'serial'}</td>" if $var{'serial'};

print "</tr></table>

<p>
  <table border=1 width=620>
    <tr><th align=left>Part Number</th><th width=280 align=left>Description</th><th>Qt'y</th>
";

print "<th align=right>List Price</th>" if $var{'showlist'};
print "<th width=60 align=right>Price</th><th width=75 align=right>Total</th></tr>\n";

$n = @pn;
for ($i = 0; $i < $n; $i++) {
    $pn = $pn[$i++];
    $desc = $pn[$i++];
    $qty = $pn[$i++];
    $price = $pn[$i++];
    $listp = $pn[$i];

    if ($qty) {
	print "<tr><td>$pn</td><td>$desc</td><td align=right>$qty</td>\n";
	
	if ($var{'showlist'}) {
	    print "<td align=right>";
	    printf("%.2f", $listp * $var{'exchange'});
	    print "</td>";
	}
	
	print "<td align=right>";
	printf("%.2f", $price * $var{'exchange'});
	print "</td><td align=right>";
	$t = sprintf("%.2f", $price * $var{'exchange'} * $qty);
	$total += $t;
	printf("%.2f", $t);
	print "</td></tr>\n";
    }
}

if ($var{'showlist'}) {
  print "<tr><td colspan=6>&nbsp;</td></tr>";
} else {
  print "<tr><td colspan=5>&nbsp;</td></tr>";
}

if ($var{'shipping'}) {
    if ($var{'showlist'}) {
      print "<tr><th colspan=5 align=right>Freight</td>";
    } else {
      print "<tr><th colspan=4 align=right>Freight</td>";
    }
    
    print "<td align=right>";
    $t = sprintf("%.2f", $var{'shipping'} * $var{'exchange'});
    $total += $t;
    printf("%.2f", $t);
    print "</td></tr>";
}

if ($var{'showlist'}) {
  print "<tr><th colspan=5 align=right>Subtotal</td>";
} else {
  print "<tr><th colspan=4 align=right>Subtotal</td>";
}

print "<td align=right>";
printf("%.2f", $total);
print "</td></tr>";


if ($var{'tax1'}) {
    if ($var{'showlist'}) {
      print "<tr><th colspan=5 align=right>GST</td>";
    } else {
      print "<tr><th colspan=4 align=right>GST</td>";
    }
    
    print "<td align=right>";
    $gst = sprintf("%.2f", $total * $var{'tax1'}/100 * $var{'exchange'});
    printf("%.2f", $gst);
    print "</td></tr>";
}

if ($var{'tax2'}) {
    if ($var{'showlist'}) {
      print "<tr><th colspan=5 align=right>PST</td>";
    } else {
      print "<tr><th colspan=4 align=right>PST</td>";
    }
    
    print "<td align=right>";
    $pst = sprintf("%.2f", $total * $var{'tax2'}/100 * $var{'exchange'});
    printf("%.2f", $pst);
    print "</td></tr>";
}

if ($var{'showlist'}) {
  print "<tr><th colspan=5 align=right>Total</td>";
} else {
  print "<tr><th colspan=4 align=right>Total</td>";
}

print "<td align=right>";
printf("<b>%.2f</b>", $total + $gst + $pst);
print "</td></tr>

</table>

<p>
  $msg
";


print "<center>

All prices in $var{'currency'} funds.";

if ($var{'terms'} eq "NET 30") {
  print "Please make cheque payable to $mycompany";
}

print "<br><b>THANK YOU for your valued business!</b>
</center>";

# signature
#@a = split(/\t/, $user[2]);

#foreach $item (@a) {
#    print "$item<br>";
#}
# translate tab to newline and save in var
#$user[2] =~ tr/\t/\n/;
#$var{'mysig'} = &escape($user[2]);


if ($var{'byemail'}) {
  if ($var{'email'}) {
    $fh = </home/nobody/rfq/$$>;
    open(DATA, ">$fh") || die "Cannot open $fh";

    $var{'message'} = &escape($var{'message'});

    while (($key, $value) = each %var) {
	print DATA "$key=$value\n";
    }

    print DATA "\n";
    $n = @pn;
    for ($i = 0; $i < $n; $i++) {
	$str = "";
	for (0..4) {
	    $str .= "@pn[$i++]\t";
	}
	chop $str;
	print DATA "$str\n";
	$i--;
    }
    
    print "<p><input name=var type=hidden value=\"$fh\"";
    print "<p><input type=submit value=\"send Invoice to $var{'email'}\">";

    close(DATA);
  }
}

print "
</form>
";


#close(USERLOG);

