#!/usr/bin/perl


use Pg;
require('../common/config');
require('../common/wwwutil');


# open stdin
read(STDIN, $_, $ENV{'CONTENT_LENGTH'});

# connect to database
$conn = PQsetdb($pghost, $pgport, $pgoptions, $pgtty, $dbname);
(PQstatus($conn) == PGRES_CONNECTION_OK) || die "Could not connect to database $dbname";


# put items in array
split(/&/);

foreach (@_) {
  @a = split(/=/);

  push(@var, $a[0]);
  push(@var, $a[1]);
}

%var = @var;


$query = "update parts set";


$var{'description'} = uc &unescape($var{'description'});
$query .= " description = \'$var{'description'}\'";

$var{'list_price'} = $var{'list_price'} ? $var{'list_price'} : 0;
$query .= ",list_price = $var{'list_price'}";

$query .= ",list_curr = \'$var{'list_curr'}\'";

# split make into id and name
@a = split(/--/, $var{'make'});     # CAT -- 1
$var{'make'} = $a[1];                 # assign ID

$query .= ",make = $var{'make'}";

$var{'weight_kg'} = $var{'weight_kg'} ? $var{'weight_kg'} : 0;
$query .= ",weight_kg = $var{'weight_kg'}";

$var{'sell_price'} = $var{'sell_price'} ? $var{'sell_price'} : 0;
$query .= ",sell_price = $var{'sell_price'}";

$query .= ",sell_curr = \'$var{'sell_curr'}\'";


# notes
# $var{'notes'} =~ s/%0[dD]//g;
$var{'notes'} = uc &unescape($var{'notes'});
$query .= ",notes = \'$var{'notes'}\'";

# model
$var{'model'} = uc &unescape($var{'model'});
$query .= ",model = \'$var{'model'}\'";

# serialnumber
$var{'serialnumber'} = uc &unescape($var{'serialnumber'});
$query .= ",serialnumber = \'$var{'serialnumber'}\'";

# priceupdate
if ($var{'priceupdate'}) {
  $query .= ",priceupdate = \'$var{'priceupdate'}\'";
}


# add oid
$query .= " where number = \'$var{'number'}\' and oid = $var{'oid'};";
$pt = PQexec($conn, $query);

$result = PQresultStatus($pt);

# clear memory
PQclear($pt);

PQfinish($conn);


if ($result) {
  print "Content-type: text/html
Location: search.pl?$var{'number'}

  <body bgcolor=ffffff>

  <h2>Status</h2>

  <h2><font color=blue>Updated Part Number: $var{'number'}</font></h2>";
} else {
  print "Content-type: text/html
  
  <body bgcolor=ffffff>
  
  <h2><font color=red>Failed to update Part Number: $var{'number'}</font></h2>";
}


print "
</body>
</html>
";

