#!/usr/bin/perl


use Pg;
require('../common/config');
require('../common/wwwutil');
require('replayout');


# read STDIN
read(STDIN, $_, $ENV{'CONTENT_LENGTH'});

# store in array
@a = split(/&/);

foreach $item (@a) {
  ($key, $value) = split(/=/,$item);
  $var{$key} = $value;
}


print "Content-type: text/html

<title>Supplier List</title>

<body bgcolor=ffffff>
";


if (&chklength($var{'searchtext'}, 3)) {
  exit;
}


# connect to database
$conn = PQsetdb($pghost, $pgport, $pgoptions, $pgtty, $dbname);
(PQstatus($conn) == PGRES_CONNECTION_OK) || die "Could not connect to database $dbname";


print "
<h2>Suppliers</h2>

<pre>
";


$var{'searchtext'} = &unescape($var{'searchtext'});
$fld = uc $var{'searchtext'};

$query = "select *,oid from supplier ";
$query .= "where $var{'whichfield'} like \'%$fld%\' order by name;";

$ct = PQexec($conn, $query);
$n = PQntuples($ct);

if ($n) {
  for $i (0 .. $n-1) {
    &listsupplier($ct, $i);
  }
} else {
  print "<h2><font color=red>Supplier: $var{'searchtext'} not on file!</font></h2>";
}

PQclear($ct);

PQfinish($conn);

print "
</pre>

</body>
</html>
";

