\connect - login
CREATE SEQUENCE id start 1 increment 1 maxvalue 2147483647 minvalue 1  cache 1 ;
SELECT nextval ('id');
\connect - login
CREATE TABLE make (id int4 DEFAULT nextval ( 'id' ), name text);
\connect - login
CREATE TABLE currency (id char(3), name text, buy float4, sell float4);
\connect - login
CREATE TABLE supply (number varchar(16), supplier_id int4, cost_price float4, cost_curr char(3) DEFAULT 'CDN', notes text, priceupdate date);
\connect - login
CREATE TABLE company (name varchar(35), addr1 varchar(35), addr2 varchar(35), addr3 varchar(35), contact varchar(35), phone varchar(20), fax varchar(20), email text, website text, notes text);
\connect - login
CREATE TABLE alternate (oem_number varchar(16), alt_number varchar(16), alt_make int4, oem_make int4);
\connect - login
CREATE TABLE chqcdn (transdate date, description text, amount float4, chqnumber int2, cleared bool);
\connect - login
CREATE TABLE chqus (transdate date, description text, amount float4, chqnumber int2, cleared bool);
\connect - login
CREATE TABLE customer (id int4 DEFAULT nextval ( 'id' ), name varchar(35), addr1 varchar(35), addr2 varchar(35), addr3 varchar(35), contact varchar(35), phone varchar(20), fax varchar(20), email text, notes text, ytd float4, discount float4, tax1 float4, tax2 float4, creditlimit float4, terms int2);
\connect - login
CREATE TABLE vendor (id int4 DEFAULT nextval ( 'id' ), name varchar(35), addr1 varchar(35), addr2 varchar(35), addr3 varchar(35), contact varchar(35), phone varchar(20), fax varchar(20), email text, notes text, ytd float4);
\connect - login
CREATE TABLE supplier (id int4 DEFAULT nextval ( 'id' )) inherits ( company);
\connect - login
CREATE TABLE parts (number varchar(16), description varchar(35), list_price float4, list_curr char(3) DEFAULT ( 'CDN' ), make int4, weight_kg float4, sell_price float4, sell_curr char(3) DEFAULT ( 'CDN' ), notes text, model text, serialnumber text, priceupdate date);
\connect - login
CREATE TABLE ap (invnumber text, invdate date, vendor int4, amount float4, tax1 float4, tax2 float4, currency char(3) DEFAULT ( 'CDN' ), amountpaid float4, datepaid date, duedate date, ordnumber text, chqnumber int2);
\connect - login
CREATE TABLE ar (invnumber text, invdate date, customer int4, amount float4, tax1 float4, tax2 float4, currency char(3) DEFAULT ( 'CDN' ), amountpaid float4, datepaid date, duedate date);
CREATE  INDEX spartno on supply using hash ( number varchar_ops );
CREATE  INDEX partno on parts using hash ( number varchar_ops );
INSERT into currency values ('CDN', 'CANADIAN DOLLAR', 1, 1);
