#!/usr/bin/perl


use Pg;
require('../common/config');
require('../common/selection');

$callback = $ENV{'QUERY_STRING'};

print "Content-type: text/html

<title>Accounts Payables</title>

<body bgcolor=ffffff>
";


# connect to database
$conn = PQsetdb($pghost, $pgport, $pgoptions, $pgtty, $dbname);
(PQstatus($conn) == PGRES_CONNECTION_OK) || die "Could not connect to database $dbname";

# match ID, set variable to 'vendor', retrieve from vendor table
$vendors = &buildselection("", "vendor", "vendor");

# currency is separate, returns only character selection
$curr = &currselection("CDN", "currency");


print "
<h2>Adding Accounts Payables Transaction</h2>

<form method=post action=addit.pl>

<table border=1>
<tr valign=top>
<td>
<table>

<tr>
<th align=right>Vendor:</th><td colspan=3>$vendors</td>
</tr>

<tr>
<th align=right>Invoice Number:</th><td><input name=invnumber size=12></td>
<th align=right>Order Number:</th><td><input name=ordnumber size=8></td>
</tr>

<tr>
<th align=right>Invoice Date:</th><td><input name=invdate size=10></td>
<th align=right>Due Date:</th><td><input name=duedate size=10></td>
</tr>

<tr>
<th align=right>Amount:</th><td><input name=amount size=10> $curr</td>
<th align=right>GST:</th><td><input name=tax1 size=8></td>
</tr>

<tr>
<th align=right>Date Paid:</th><td><input name=datepaid size=10> 
<b>Chq #: </b><td><input name=chqnumber size=4></td>
<th align=right>Amount Paid:</th><td><input name=amountpaid size=10></td>
</tr>

</table>
</td>

</tr>
</table>

<input type=hidden name=callback value=$callback?$callback>
<p><input type=submit value=\"Add Transaction\">
</form>
";

PQfinish($conn);

print "
<p>Enter dates in mm/dd/xxyy or mm-dd-xxyy format; (xx) is optional.
<p><a href=/vendor/add.pl>Click here</a> to add a new vendor.
<br><a href=/currency/add.pl>Click here</a> to add a new currency symbol.

</body>
</html>
";


