#!/usr/bin/perl


use Pg;
require('../common/config');


print "Content-type: text/html

<body bgcolor=ffffff>

<h2>Makes</h2>
";


# connect to database
$conn = PQsetdb($pghost, $pgport, $pgoptions, $pgtty, $dbname);
(PQstatus($conn) == PGRES_CONNECTION_OK) || die "Could not connect to database $dbname";


$query = "select *,oid from make order by name;";
$makes = PQexec($conn, $query);
$n = PQntuples($makes);


if ($n) {

  print "<pre>\n";

  for $i (0..$n-1) {

    $id = PQgetvalue($makes, $i, 0);
    $name = PQgetvalue($makes, $i, 1);
    $oid = PQgetvalue($makes, $i, 2);
    $nm = $name;
    $nm =~ s/ /%20/g;
    $name = substr($name,0,20);
    
    printf("%s %4d <a href=edit.pl?%d&%s>%s</a>", $padding, $id, $oid, $nm, $name);
    $padding = "   ";
    $fillout = " " x (20 - length($name));
    print $fillout;

    $col++;
    
    if ($col >2) {
      $padding = "";
      $col = 0;
      print "\n";
    }
  }
}

PQclear($makes);
    
PQfinish($conn);


print "
</pre>

<p>Click here to <a href=add.html>Add Make</a>.
<br>Click on make to edit.

</body>
</html>
";


