#!/usr/bin/perl


use Pg;
require('../common/config');
require('../common/selection');
require('../common/wwwutil');

($number, $supplier, $cost_price, $cost_curr, $priceupdate) = split(/,/, $ENV{'QUERY_STRING'});

$supplier = &unescape($supplier);

print "Content-type: text/html\n\n";
print "<body bgcolor=ffffff>\n";


# connect to database
$conn = PQsetdb($pghost, $pgport, $pgoptions, $pgtty, $dbname);
(PQstatus($conn) == PGRES_CONNECTION_OK) || die "Could not connect to database $dbname";


$make = &buildselection("","make","make");

$list_curr = &currselection("CDN", "list_curr");
$sell_curr = &currselection("CDN", "sell_curr");

print "
<h2>Adding Details for Part Number $number</h2>

Supplier: $supplier
<br>Cost: $cost_price $cost_curr
<p>

<form method=post action=addnewpart.pl>

<table border=1>
<tr valign=top>
<td>
<table>

<tr>
<th align=right>Description:</th><td><input name=description size=35 maxlength=35></td>
<th align=right>List:</th><td><input name=list_price size=8></td><td>$list_curr</td>
</tr>

<tr>
<th align=right>Make:</th><td>$make</td>
<th align=right>Sell:</th><td><input name=sell_price size=8></td><td>$sell_curr</td>
</tr>

<tr>
<th align=right>Model:</th><td><input name=model size=35></td>
<th align=right>Weight (kg):</th><td><input name=weight_kg size=8></td>
</tr>

<tr>
<th align=right>Serial Number:</th><td><input name=serialnumber size=27></td>
<th align=right>Price update:</th><td colspan=2><input name=priceupdate value=$priceupdate size=10></td>
</tr>

<tr>
<th align=right>Notes:</th><td colspan=4><textarea name=notes cols=62 rows=4>$notes</textarea></td>
</tr>

</table>
</td>

</tr>
</table>

<input type=hidden name=number value=$number>
<p><input type=submit value=\"Add Record\">
</form>
";

PQfinish($conn);

print "
</body>
</html>
";


